---
title: API reference page template
slug: MDN/Structures/Page_types/API_reference_page_template
tags:
  - API
  - Template
  - reference page
---
<p>{{MDNSidebar}}</p>

<div class="notecard note">
<h2 id="Remove_before_publishing">Remove before publishing</h2>

<h3 id="Title_and_slug">Title and slug</h3>

<p>An API reference page should have a <em>Title</em> of <em>Name of the interface the page is about</em>. For example, the <a href="/en-US/docs/Web/API/Request">Request</a> interface page has a <em>title</em> of <em>Request</em>.</p>

<p>The <em>Slug</em> (the last segment at the end of the URL) should also be filled in as <em>Name of the interface the page is about</em>, so <code>Request</code>'s slug is <em>Request</em>. This is usually filled in for you automatically.</p>

<h3 id="Top_macros">Top macros</h3>

<p>There are five macro calls at the top of the template by default. You should update or delete them according to the advice below:</p>

<ul>
 <li>\{{APIRef("<em>GroupDataName</em>")}} — this generates the left hand reference sidebar showing quick reference links related to the current page. For example, every page in the <a href="/en-US/docs/Web/API/WebVR_API">WebVR API</a> has the same sidebar, which points to the other pages in the API. To generate the correct sidebar for your API, you need to add a GroupData entry to our KumaScript GitHub repo, and include the entry's name inside the macro call in place of <em>GroupDataName</em>. See our <a href="/en-US/docs/MDN/Contribute/Structures/API_references/API_reference_sidebars">API reference sidebars</a> guide for information on how to do this.</li>
 <li>\{{Draft}} — this generates a <strong>Draft</strong> banner that indicates that the page is not yet complete, and should only be removed when the first draft of the page is completely finished. After it is ready to be published, you can remove this.</li>
 <li>\{{SeeCompatTable}} — this generates a <strong>This is an experimental technology</strong> banner that indicates the technology is <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Experimental">experimental</a>). If the technology you are documenting is not experimental, you can remove this. If it is experimental, and the technology is hidden behind a pref in Firefox, you should also fill in an entry for it in the <a href="/en-US/docs/Mozilla/Firefox/Experimental_features">Experimental features in Firefox</a> page.</li>
 <li>\{{SecureContext_Header}} — this generates a <strong>Secure context</strong> banner that indicates the technology is only available in a <a href="/en-US/docs/Web/Security/Secure_Contexts">secure context</a>. If it isn't, then you can remove the macro call. If it is, then you should also fill in an entry for it in the <a href="/en-US/docs/Web/Security/Secure_Contexts/features_restricted_to_secure_contexts">Features restricted to secure contexts</a> page.</li>
 <li>\{{Deprecated_Header}} — this generates a <strong>Deprecated</strong> banner that indicates the technology is <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Deprecated_and_obsolete">deprecated</a>. If it isn't, then you can remove the macro call.</li>
 <li>\{{Interface_Overview("<em>GroupDataName</em>")}} {{Experimental_Inline}} — this generates the main body of the page (Constructor, Properties, Methods and Events).</li>
</ul>

<h3 id="Tags">Tags</h3>

<p>In an API reference page, you need to include the following tags (see the <em>Tags</em> section at the bottom of the editor UI): <strong>API</strong>, <strong>Reference</strong>, <strong>Interface</strong>, <em>the name of the API</em> (e.g. <strong>WebVR</strong>), the name of the interface (e.g. <strong>Request</strong>), <strong>Experimental</strong> (if the technology is <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Experimental">experimental</a>), <strong>Secure context</strong> (if it is available in a secure context only), and <strong>Deprecated</strong> (if it is <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Deprecated_and_obsolete">deprecated</a>).</p>

<p>Optionally, you can elect to include some other tags that effective represent terms people might search for when looking for information on that technology. For example on WebVR interface pages we include <strong>VR</strong> and <strong>Virtual reality</strong>.</p>

<h3 id="Browser_compatibility">Browser compatibility</h3>

<p>To fill in the browser compat data, you first need to fill in an entry for the API into our <a href="https://github.com/mdn/browser-compat-data">Browser compat data repo</a> — see our <a href="/en-US/docs/MDN/Contribute/Structures/Compatibility_tables#The_new_way_The_browser_compat_data_repo_and_dynamic_tables">guide on how to do this</a>.</p>

<p>Once that is done, you can show the compat data for the interface with a \{{Compat(…)}} macro call.</p>
</div>

<p>{{APIRef("GroupDataName")}}{{Draft}}{{SeeCompatTable}}{{SecureContext_Header}}{{Deprecated_Header}}</p>

<p class="summary">The summary paragraph — start by naming the interface, saying what API it is part of, and saying what it does. This should ideally be 1 or 2 short sentences. You could copy most of this from the Interface's summary on the corresponding API landing page.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{DOMxRef("NameOfTheInterface.NameOfTheInterface")}}</dt>
 <dd>Creates a new instance of the {{DOMxRef("NameOfTheInterface")}} object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Also inherits properties from its parent interface, {{DOMxRef("NameOfParentInterface")}}.</em> (Note: If the interface doesn't inherit from another interface, remove this whole line.)</p>

<dl>
 <dt>{{DOMxRef("NameOfTheInterface.property1")}}{{ReadOnlyInline}} {{Deprecated_Inline}}</dt>
 <dd>Include a brief description of the property and what it does here. Include one term and definition for each property. If the property is not readonly/experimental/deprecated, remove the relevant macro calls.</dd>
 <dt>{{DOMxRef("NameOfTheInterface.property2")}}</dt>
 <dd>etc.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Also inherits methods from its parent interface, {{DOMxRef("NameOfParentInterface")}}.</em> (Note: If the interface doesn't inherit from another interface, remove this whole line.)</p>

<dl>
 <dt>{{DOMxRef("NameOfTheInterface.method1()")}} {{Experimental_Inline}} {{Deprecated_Inline}}</dt>
 <dd>Include a brief description of the method and what it does here. Include one term and definition for each method. If the method is not experimental/deprecated, remove the relevant macro calls.</dd>
 <dt>{{DOMxRef("NameOfTheInterface.method2()")}}</dt>
 <dd>etc.</dd>
</dl>

<h2 id="Events">Events</h2>

<p>Listen to these events using <code><a href="/en-US/docs/Web/API/EventTarget/addEventListener">addEventListener()</a></code> or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface.</p>

<dl>
 <dt><code><a href="#">eventname1</a></code></dt>
 <dd>Fired when ... include description of when event fires<br>
 Also available via the <code><a href="#">oneventname1</a></code> property.</dd>
 <dt><code><a href="#">eventname2</a></code></dt>
 <dd>Fired when ... include description of when event fires<br>
 Also available via the <code><a href="#">oneventname2</a></code> property.</dd>
 <dt>etc.</dt>
</dl>

<h2 id="Examples">Examples</h2>

<p>Fill in a simple example that nicely shows a typical usage of the interfaces, then perhaps some more complex examples (see our guide on how to add <a href="/en-US/docs/MDN/Contribute/Structures/Code_examples">code examples</a> for more information).</p>

<pre class="brush: js notranslate">my code block</pre>

<p>And/or include a list of links to useful code samples that live elsewhere:</p>

<ul>
 <li>x</li>
 <li>y</li>
 <li>z</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("NameOfOtherSpecification", "#document-fragment-linking-directly-to-feature-definition", "NameOfTheFeature")}}</td>
   <td>{{Spec2("NameOfOtherSpecification")}}</td>
   <td>Defines blah blah feature. If no other specs define specific subfeatures of this interface, you can delete this table row.</td>
  </tr>
  <tr>
   <td>{{SpecName("NameOfSpecification", "#document-fragment-linking-directly-to-interface-definition", "NameOfTheInterface")}}</td>
   <td>{{Spec2("NameOfSpecification")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility_2">Browser compatibility</h2>

<p>{{Compat("path.to.feature.NameOfTheInterface")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Include list of</li>
 <li>other links related to</li>
 <li>this API that might</li>
 <li>be useful</li>
</ul>
